import 'package:stripe_payment/stripe_payment.dart';

abstract class ClientPaymentService {

  static void setPublishableKey() {
    StripePayment.setOptions(StripeOptions(publishableKey: "pk_test_51GqbBIBChwyaIibntfVplA8JNzSvhQGzWrNATOlETJnWqPtNq72jrfMTTaGLrcF0IYmabd4thwINygnxlR5yCVjP00vLTqaxHS", merchantId: "Test", androidPayMode: "test"));
  }

  static Future<void> confirmPayment(String paymentMethodId, String clientSecret) async {
    await StripePayment.confirmPaymentIntent(PaymentIntent(clientSecret: clientSecret, paymentMethodId: paymentMethodId));
  }

  static Future<void> confirmSetup(PaymentMethod paymentMethod, String clientSecret) async {
    await StripePayment.confirmSetupIntent(PaymentIntent(clientSecret: clientSecret, paymentMethodId: paymentMethod.id));
  }

  static Future<PaymentMethod> enterCard() async {
    return StripePayment.paymentRequestWithCardForm(CardFormPaymentRequest());
  }

  static Future<PaymentMethod> useNativePay(double amount, String currency) async {
    Token token;

    try {
      token = await StripePayment.paymentRequestWithNativePay(
        androidPayOptions: AndroidPayPaymentRequest(
          totalPrice: "$amount",
          currencyCode: currency,
        ),
        applePayOptions: ApplePayPaymentOptions(
          countryCode: "PL",
          currencyCode: currency,
          items: [
            ApplePayItem(
              label: 'Test',
              amount: "$amount",
            )
          ],
        ),
      );

      print(1);

      await StripePayment.completeNativePayRequest();
    } catch(error) {
      await StripePayment.cancelNativePayRequest();
    }

    print(2);

    print(token);

    final PaymentMethod paymentMethod = await StripePayment.createPaymentMethod(PaymentMethodRequest(card: CreditCard(token: token.tokenId)));

    return paymentMethod;
  }

}