import 'package:cloud_functions/cloud_functions.dart';

abstract class ServerPaymentService {

  static Future<Map<String, dynamic>> getClientSecretForPayment(double amount, String currency) async {
    final HttpsCallable callable = CloudFunctions.instance.getHttpsCallable(functionName: 'createPayment');

    final HttpsCallableResult result = await callable.call({
      "amount": amount * 100.0,
      "currency": currency
    });

    final Map<String, dynamic> intent = result.data;

    return intent;
  }

  static Future<Map<String, dynamic>> getClientSecretForSetup() async {
    final HttpsCallable callable = CloudFunctions.instance.getHttpsCallable(functionName: 'createSetup');

    final HttpsCallableResult result = await callable.call();

    final Map<String, dynamic> intent = result.data.cast<String, dynamic>();

    return intent;
  }

  static Future<Map<String, dynamic>> getClientSecretAndPaymentMethod(String customerId, double amount, String currency) async {
    final HttpsCallable callable = CloudFunctions.instance.getHttpsCallable(functionName: 'createPaymentWithCustomerId');

    final HttpsCallableResult result = await callable.call({
      "customerId": customerId,
      "amount": amount * 100.0,
      "currency": currency
    });

    final Map<String, dynamic> intent = result.data.cast<String, dynamic>();

    return intent;
  }

}